<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

/**
 * This is the main inclusion file for the Remote index addon
 * 
 * The remote index addon allows to search teamweaverIS backend instances
 * from within MediaWiki. The connection is realized via webservices 
 */

// Autoload addon classes
woogleAutoloadClasses(array(
	'WoogleQueryManagerRemote'	=> '/addons/Remote',
	'WoogleQueryServiceRemote'	=> '/addons/Remote',
	'WoogleIndexServiceRemote'	=> '/addons/Remote',
));

// Configure addon default values
woogleConfigureAddon(array(
	'indexAddon'			    => array('Remote', 				'addon used for the Woogle index (either "Native" or "Remote"'), // overwrites default from WoogleConfig
	'indexRepository'			=> array(1234,					'repository id this wiki should use in the index'),
	'timeout'					=> array(300,					'timeout if the QueryService is down (in seconds)'),
	'indexGroups'				=> array(array('fzi', 'ls3'),	'groups transmitted if a user is member'),
	'remoteAuthKey'				=> array("anonymous",			'authKey being passed to the remote backend'),
	'remoteBaseServiceUrl'		=> array('http://localhost:8080/teamweaverIS-backend/services/',
																'remote service base url of teamweaverIS backend - e.g. http://localhost:8080/teamweaverIS-backend/services/'),
	'remoteQueryServiceUrl'		=> array('',					'remote query service url - leave empty for default! Consists of remoteQueryServiceUrl plus "phpQuery" (e.g. http://localhost:8080/teamweaverIS-backend/services/phpQuery)'),
	'remoteUpdateServiceUrl'	=> array('',					'remote update service url - leave empty for default! Consists of remoteQueryServiceUrl plus "phpUpdate" (e.g. http://localhost:8080/teamweaverIS-backend/services/phpUpdate)'),
	'remoteIndexServiceUrl'		=> array('',					'remote index service url - leave empty for default! Consists of remoteQueryServiceUrl plus "phpIndex" (e.g. http://localhost:8080/teamweaverIS-backend/services/phpIndex)'),
	'remoteQueryManagerUrl'		=> array('',					'remote query manager service url - leave empty for default! Consists of remoteQueryServiceUrl plus "phpQueryManager" (e.g. http://localhost:8080/teamweaverIS-backend/services/phpQueryManager)'),
	'remoteOptions'				=> array(array('username' => 'waves', 'password' => 'trrwd'),
																'options being passed to the HessianClient'),
	'remoteServiceName'			=> array('Woogle4MediaWiki',	'service name being passed to the remote backend'),
	'remoteServiceVersion'		=> array(W4M_VERSION,			'service version being passed to the remote backend'),
	'remotePushIndexAuthKey'	=> array('dummyKey',			'key the push index is called with to authenticate'),

));

?>