<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

// TODO add profiling

class WooglePDFExtractor {

	/*
	 * Tries to extract readable fulltext from a PDF file 
	 * 
	 * @param $filename			string, local filename
	 * @return					String, extracted text content
	 
	public static function pdfFilename2string($filename){
		$res = false;
		
		self::pdfFile2string();
	}*/
	
	/**
	 * Tries to extract readable fulltext from a PDF file 
	 * 
	 * @param $file				file handle
	 * @return					String, extracted text content
	 */
	public static function pdfFile2string($sourcefile){
		$res = false;
		
	    $fp = fopen($sourcefile, 'rb'); 
	    $res = fread($fp, filesize($sourcefile)); 
	    fclose($fp); 

	    $res = self::pdfcontent2string($res);
	    
	    return $res;
	}
	
	/**
	 * Tries to extract readable fulltext from a PDF file 
	 * 
	 * @param $content		string, raw binary content of a pdf file
	 * @return					String, extracted text content
	 */
	public static function pdfcontent2string($content) { 
		
	    $searchstart = 'stream'; 
	    $searchend = 'endstream'; 

	    $pdfText = ''; 
	    $pos = 0; 
	    $pos2 = 0; 
	    $startpos = 0; 

	    while ($pos !== false && $pos2 !== false) { 
	        $pos = strpos($content, $searchstart, $startpos); 
	        $pos2 = strpos($content, $searchend, $startpos + 1); 

	        if ($pos !== false && $pos2 !== false){ 
	            if ($content[$pos] == 0x0d && $content[$pos + 1] == 0x0a) { 
	                $pos += 2; 
	            } else if ($content[$pos] == 0x0a) { 
	                $pos++; 
	            } 

	            if ($content[$pos2 - 2] == 0x0d && $content[$pos2 - 1] == 0x0a) { 
	                $pos2 -= 2; 
	            } else if ($content[$pos2 - 1] == 0x0a) { 
	                $pos2--; 
	            } 

	            $textsection = substr( 
	                $content, 
	                $pos + strlen($searchstart) + 2, 
	                $pos2 - $pos - strlen($searchstart) - 1 
	            ); 

	            $data = @gzuncompress($textsection); 
	            $pdfText .= self::pdfExtractText($data); 
	            $startpos = $pos2 + strlen($searchend) - 1; 
	        } 
	    } 

		$pdfText = preg_replace('/(\s)+/', ' ', $pdfText); 
		$pdfText = utf8_encode($pdfText);
		
	   	WoogleUtil::debug('PDFExtractor: contents of pdf file: ' . substr($pdfText, 0, 1000));

			//$pdfText = self::convertLatin( $pdfText );
			$pdfText = str_replace ( '\344', 'ä', $pdfText);
			$pdfText = str_replace ( '\374', 'ü', $pdfText);
			$pdfText = str_replace ( '\366', 'ö', $pdfText);
			$pdfText = str_replace ( '\304', 'Ä', $pdfText);
			$pdfText = str_replace ( '\326', 'Ö', $pdfText);
			$pdfText = str_replace ( '\334', 'Ü', $pdfText);
			$pdfText = str_replace ( '\337', 'ß', $pdfText);

		//	$pdfText = preg_replace("/[^a-zA-Z0-9(),!\-\.\?äüöÄÖÜß\s]/", "", $pdfText);
		$pdfText = preg_replace("/[^a-zA-Z0-9äüöÄÖÜß\s]/", "", $pdfText);
			//$pdfText = preg_replace("/[^a-zA-Z0-9\s]/", "", $pdfText);
			
	   	WoogleUtil::debug('PDFExtractor: contents of pdf file (after str_replace): ' . substr($pdfText, 0, 1000) );
			
			//$pdfText = preg_replace("/[^a-zA-Z0-9\s]/", "", $pdfText);
			
			return $pdfText;
	} 

	private static function pdfExtractText($psData){ 

	    if (!is_string($psData)) { 
	        return ''; 
	    } 

	    $text = ''; 

	    // Handle brackets in the text stream that could be mistaken for 
	    // the end of a text field. I'm sure you can do this as part of the 
	    // regular expression, but my skills aren't good enough yet. 
	    $psData = str_replace('\)', '##ENDBRACKET##', $psData); 
	    $psData = str_replace('\]', '##ENDSBRACKET##', $psData); 

	    preg_match_all( 
	        '/(T[wdcm*])[\s]*(\[([^\]]*)\]|\(([^\)]*)\))[\s]*Tj/si', 
	        $psData, 
	        $matches); 

    	for ($i = 0; $i < sizeof($matches[0]); $i++) { 

	        if ($matches[3][$i] != '') { 
	            // Run another match over the contents. 
	            preg_match_all('/\(([^)]*)\)/si', $matches[3][$i], $subMatches); 

	            foreach ($subMatches[1] as $subMatch) { 
	                $text .= $subMatch; 
	            } 

	        } else if ($matches[4][$i] != '') { 
	            $text .= ($matches[1][$i] == 'Tc' ? ' ' : '') . $matches[4][$i]; 
	        } 

    	} 

	    // Translate special characters and put back brackets. 

		$trans = array( 
	        '...'                => '…', 
	        '\205'                => '…', 
	        '\221'                => chr(145), 
	        '\222'                => chr(146), 
	        '\223'                => chr(147), 
	        '\224'                => chr(148), 
	        '\226'                => '-', 
	        '\267'                => '•', 
	        '\('                => '(', 
	        '\['                => '[', 
	        '##ENDBRACKET##'    => ')', 
	        '##ENDSBRACKET##'    => ']', 
	        chr(133)            => '-', 
	        chr(141)            => chr(147), 
	        chr(142)            => chr(148), 
	        chr(143)            => chr(145), 
	        chr(144)            => chr(146), 
	    ); 

	    $text = strtr($text, $trans); 
	    return $text; 
	} 
	
	public static function convertLatin($s){
		$pattern = '/[[\\\\][0-9]{3}|[\\\\][0-9]{2}|[\\\\][0-9]]/';
		$callback_fn = 'WooglePDFExtractor::latin2ansi';
		//print "i'm in the convert function <br />";
		return preg_replace_callback($pattern, $callback_fn, $s);
	}

	// takes octoal latin1 values ('\374') and returns 'ü'
	public static function latin2ansi($s){
		//print 'i\'m in the latin2ansi function <br />';
		$i = str_replace('\\', '', $s[0]); // strip leading slash
		//WoogleUtil::debug("latin2ansi: octal i:" . $i );
		//$i = octdec( $i );
		//WoogleUtil::debug("latin2ansi: decimal i:" . $i );
		$char = chr(intval($i, 8));
		WoogleUtil::debug("WooglePDFExtractor converted " . $s . " to " . $char); 
		return $char;
	}

}

?>
