<?php
/*******************************************************************************
*	This file is part of Woogle4MediaWiki
*   (http://www.mediawiki.org/wiki/Extension:Woogle4MediaWiki)
*
*	Copyright (c) 2007 - 2009 Hans-Jörg Happel and
*	FZI Forschungszentrum Informatik and der Universität Karlsruhe (TH)
*
*   Woogle4MediaWiki is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   Woogle4MediaWiki is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with Woogle4MediaWiki.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/ 

/**
 * Creates query suggestions for OpenSearch (@see opensearch.php)
 */

require_once('blankstart.php');

WoogleUtil::profileIn('suggest.php');

$query = $_GET['q'];

try {
	$suggestions = WoogleUtil::getQueryService()->getAutoComplete($query, 10);
	// WoogleUtil::info('Vorschläge: '.print_r($suggestions) );
} catch (Exception $e) {
	WoogleUtil::error("suggest.php" . $e->getMessage());
	exit;
}

header('Content-type: application/x-suggestions+json');

$terms = '';
$descs = '';

foreach ($suggestions as $suggestion) {
	if (!empty($terms)) {
		$terms .= ',';
		$descs .= ',';
	}
	$terms .= '"' . $suggestion['entity'] . '"';
	$descs .= '"' . $suggestion['freq'] . '"';
/*	foreach ($suggestion as $s) {
		echo $s . ',';
	}
	echo ';';*/
}

$results = '["' . $query . '",[' . $terms . '],[' . $descs . ']]';
// $results = '["' . $query . '",[' . $terms . ']]';

// $results = '["deut",["Deuterium","Deutschland"]]';

// WoogleUtil::info('Vorschläge: '.$results);


echo $results;

WoogleUtil::profileOut('suggest.php');

?>
